rpm 5.2.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- File List
- Globals

Data Structures | Macros | Typedefs | Functions | Variables
macro.c File Reference
RPMRC. | RPMIO.
`#include "system.h"`
`#include <stdarg.h>`
`#include <rpmio_internal.h>`
`#include <rpmlog.h>`
`#include <mire.h>`
`#include <rpmficl.h>`
`#include <rpmjs.h>`
`#include <rpmperl.h>`
`#include <rpmpython.h>`
`#include <rpmruby.h>`
`#include <rpmtcl.h>`
`#include <rpmuuid.h>`
`#include <rpmmacro.h>`
`#include "debug.h"`
Include dependency graph for macro.c:

Go to the source code of this file.

## Data Structures
struct | MacroBuf_s
| Macro expansion state. More...

## Macros
#define | isblank(_c) ((char)(_c) == ' ' || (char)(_c) == '\t')
#define | iseol(_c) ((char)(_c) == '\n' || (char)(_c) == '\r')
#define | STREQ(_t, _f, _fn) ((_fn) == (sizeof(_t)-1) && !strncmp((_t), (_f), (_fn)))
#define | _MACRO_INTERNAL
#define | SAVECHAR(_mb, _c) { *(_mb)->t = (char) (_c), (_mb)->t++, (_mb)->nb--; }
#define | _MAX_MACRO_DEPTH 16
#define | _PRINT_MACRO_TRACE 0
#define | _PRINT_EXPAND_TRACE 0
#define | MACRO_CHUNK_SIZE 16
#define | SKIPBLANK(_s, _c)
#define | SKIPNONBLANK(_s, _c)
#define | COPYNAME(_ne, _s, _c)
#define | COPYOPTS(_oe, _s, _c)
#define | POPT_ERROR_NOARG -10
#define | POPT_ERROR_BADQUOTE -15
#define | POPT_ERROR_MALLOC -21
#define | POPT_ARGV_ARRAY_GROW_DELTA 5
#define | _suffix(_s, _x) (slen >= sizeof(_x) && !strcmp((_s)+slen-(sizeof(_x)-1), (_x)))

## Typedefs
typedef struct MacroBuf_s * | MacroBuf

## Functions
static int | expandMacro (MacroBuf mb)
| Parse args and string for PHP like %{foo <args> : <string> } syntax. More...
static int | compareMacroName (const void *ap, const void *bp)
| Compare macro entries by name (qsort/bsearch). More...
static void | expandMacroTable (MacroContext mc)
| Enlarge macro table. More...
static void | sortMacroTable (MacroContext mc)
| Sort entries in macro table. More...
static char * | dupMacroEntry (MacroEntry me)
void | rpmDumpMacroTable (MacroContext mc, FILE *fp)
| Print macros to file stream. More...
int | rpmGetMacroEntries (MacroContext mc, void *_mire, int used, const char ***avp)
| Return macro entries as string array. More...
static MacroEntry * | findEntry (MacroContext mc, const char *name, size_t namelen)
| Find entry in macro table. More...
static char * | rdcl (char *buf, size_t size, FD_t fd)
| fgets(3) analogue that reads \ continuations. More...
static const char * | matchchar (const char *p, char pl, char pr)
| Return text between pl and matching pr characters. More...
static void | printMacro (MacroBuf mb, const char *s, const char *se)
| Pre-print macro expression to be expanded. More...
static void | printExpansion (MacroBuf mb, const char *t, const char *te)
| Post-print expanded macro expression. More...
static int | expandT (MacroBuf mb, const char *f, size_t flen)
| Save source and expand field into target. More...
static int | expandU (MacroBuf mb, char *u, size_t ulen)
| Save source/target and expand macro in u. More...
static int | doShellEscape (MacroBuf mb, const char *cmd, size_t clen)
| Expand output of shell command into target buffer. More...
static const char * | doDefine (MacroBuf mb, const char *se, int level, int expandbody)
| Parse (and execute) new macro definition. More...
static const char * | doUndefine (MacroContext mc, const char *se)
| Parse (and execute) macro undefinition. More...
static void | pushMacro (MacroEntry *mep, const char *n, const char *o, const char *b, int level)
| Push new macro definition onto macro entry stack. More...
static void | popMacro (MacroEntry *mep)
| Pop macro definition from macro entry stack. More...
static void | freeArgs (MacroBuf mb)
| Free parsed arguments for parameterized macro. More...
static const char * | grabArgs (MacroBuf mb, const MacroEntry me, const char *se, const char *lastc)
| Parse arguments (to next new line) for parameterized macro. More...
static void | doOutput (MacroBuf mb, int waserror, const char *msg, size_t msglen)
| Perform macro message output. More...
static void | doFoo (MacroBuf mb, int negate, const char *f, size_t fn, const char *g, size_t gn)
| Execute macro primitives. More...
static int | expandFIFO (MacroBuf mb, MacroEntry me, const char *g, size_t gn)
static int | XpoptDupArgv (int argc, const char **argv, int *argcPtr, const char ***argvPtr)
static int | XpoptParseArgvString (const char *s, int *argcPtr, const char ***argvPtr)
int | rpmSecuritySaneFile (const char *filename)
| Check whether configuration file is moderately secure to load. More...
int | rpmGlob (const char *patterns, int *argcPtr, const char ***argvPtr)
| Return URL path(s) from a (URL prefixed) pattern glob. More...
int | expandMacros (void *spec, MacroContext mc, char *sbuf, size_t slen)
| Expand macro into buffer. More...
void | addMacro (MacroContext mc, const char *n, const char *o, const char *b, int level)
| Add macro to context. More...
void | delMacro (MacroContext mc, const char *n)
| Delete macro from context. More...
int | rpmDefineMacro (MacroContext mc, const char *macro, int level)
| Define macro in context. More...
int | rpmUndefineMacro (MacroContext mc, const char *macro)
| Undefine macro in context. More...
void | rpmLoadMacros (MacroContext mc, int level)
| Load macros from specific context into global context. More...
int | rpmLoadMacroFile (MacroContext mc, const char *fn)
| Load macro context from a macro file. More...
void | rpmInitMacros (MacroContext mc, const char *macrofiles)
| Initialize macro context from set of macrofile(s). More...
void | rpmFreeMacros (MacroContext mc)
| Destroy macro context. More...
int | isCompressed (const char *file, rpmCompressedMagic *compressed)
| Return type of compression used in file. More...
char * | rpmExpand (const char *arg,...)
| Return (malloc'ed) concatenated macro expansion(s). More...
char * | rpmMCExpand (MacroContext mc, const char *arg,...)
| Return (malloc'ed) concatenated macro expansion(s) in a context. More...
int | rpmExpandNumeric (const char *arg)
| Return macro expansion as a numeric value. More...
char * | rpmCleanPath (char *path)
| Canonicalize file path. More...
const char * | rpmGetPath (const char *path,...)
| Return (malloc'ed) expanded, canonicalized, file path. More...
const char * | rpmGenPath (const char *urlroot, const char *urlmdir, const char *urlfile)
| Merge 3 args into path, any or all of which may be a url. More...

## Variables
const char * | rpmMacrofiles = MACROFILES
| List of macro files to read when configuring rpm. More...
static struct MacroContext_s | rpmGlobalMacroContext_s
MacroContext | rpmGlobalMacroContext = &rpmGlobalMacroContext_s
static struct MacroContext_s | rpmCLIMacroContext_s
MacroContext | rpmCLIMacroContext = &rpmCLIMacroContext_s
int | max_macro_depth = 16
int | print_macro_trace = 0
int | print_expand_trace = 0
static size_t | _macro_BUFSIZ = 16 * 1024
static int | _debug = 0

## Macro Definition Documentation

#define _MACRO_INTERNAL

Definition at line 84 of file macro.c.

#define _MAX_MACRO_DEPTH 16

Definition at line 139 of file macro.c.

Referenced by rpmLoadMacroFile().

#define _PRINT_EXPAND_TRACE 0

Definition at line 147 of file macro.c.

#define _PRINT_MACRO_TRACE 0

Definition at line 143 of file macro.c.

#define _suffix | ( |  | _s,
|  |  | _x
| ) |  | (slen >= sizeof(_x) && !strcmp((_s)+slen-(sizeof(_x)-1), (_x)))

#define COPYNAME | ( |  | _ne,
|  |  | _s,
|  |  | _c
| ) |  |

Value:
{ SKIPBLANK(_s,_c); \
while(((_c) = (int) *(_s)) && (xisalnum(_c) || (_c) == (int) '_')) \
*(_ne)++ = *(_s)++; \
*(_ne) = '\0'; \
}

Definition at line 570 of file macro.c.

Referenced by doDefine(), and doUndefine().

#define COPYOPTS | ( |  | _oe,
|  |  | _s,
|  |  | _c
| ) |  |

Value:
{ while(((_c) = (int) *(_s)) && (_c) != (int) ')') \
*(_oe)++ = *(_s)++; \
*(_oe) = '\0'; \
}

Definition at line 577 of file macro.c.

Referenced by doDefine().

#define isblank | ( |  | _c | ) | ((char)(_c) == ' ' || (char)(_c) == '\t')

Definition at line 9 of file macro.c.

Referenced by doDefine(), doFoo(), expandMacro(), and grabArgs().

#define iseol | ( |  | _c | ) | ((char)(_c) == '\n' || (char)(_c) == '\r')

Definition at line 11 of file macro.c.

Referenced by doDefine(), doShellEscape(), doUndefine(), expandMacro(), printExpansion(), printMacro(), and rdcl().

#define MACRO_CHUNK_SIZE 16

Definition at line 152 of file macro.c.

Referenced by expandMacroTable().

#define POPT_ARGV_ARRAY_GROW_DELTA 5

Definition at line 1457 of file macro.c.

Referenced by XpoptParseArgvString().

#define POPT_ERROR_BADQUOTE -15

error in paramter quoting

Definition at line 1454 of file macro.c.

Referenced by XpoptParseArgvString().

#define POPT_ERROR_MALLOC -21

memory allocation failed

Definition at line 1455 of file macro.c.

Referenced by XpoptDupArgv(), and XpoptParseArgvString().

#define POPT_ERROR_NOARG -10

missing argument

Definition at line 1453 of file macro.c.

Referenced by XpoptDupArgv().

#define SAVECHAR | ( |  | _mb,
|  |  | _c
| ) |  | { *(_mb)->t = (char) (_c), (_mb)->t++, (_mb)->nb--; }

Definition at line 135 of file macro.c.

Referenced by doShellEscape(), and expandMacro().

#define SKIPBLANK | ( |  | _s,
|  |  | _c
| ) |  |

Value:
/*@-globs@*/ /* FIX: __ctype_b */ \
while (((_c) = (int) *(_s)) && isblank(_c)) \
(_s)++; \
/*@=globs@*/

Definition at line 558 of file macro.c.

Referenced by doDefine(), and rpmLoadMacroFile().

#define SKIPNONBLANK | ( |  | _s,
|  |  | _c
| ) |  |

Value:
/*@-globs@*/ /* FIX: __ctype_b */ \
while (((_c) = (int) *(_s)) && !(isblank(_c) || iseol(_c))) \
(_s)++; \
/*@=globs@*/

Definition at line 564 of file macro.c.

#define STREQ | ( |  | _t,
|  |  | _f,
|  |  | _fn
| ) |  | ((_fn) == (sizeof(_t)-1) && !strncmp((_t), (_f), (_fn)))

Definition at line 13 of file macro.c.

Referenced by doFoo(), and expandMacro().

## Typedef Documentation

typedef struct MacroBuf_s * MacroBuf

## Function Documentation

void addMacro | ( | MacroContext | mc,
|  | const char * | n,
|  | const char * | o,
|  | const char * | b,
|  | int | level
| ) |  |

Add macro to context.

Deprecated:
  Use rpmDefineMacro().

Parameters

  mc | macro context (NULL uses global context).
  n | macro name
  o | macro paramaters
  b | macro body
  level | macro recursion level (0 is entry API)

Definition at line 2399 of file macro.c.

References _, expandMacroTable(), findEntry(), pushMacro(), rpmGlobalMacroContext, rpmlog(), RPMLOG_ERR, and sortMacroTable().

Referenced by addMacroDefault(), addSource(), doDefine(), doSetupMacro(), expandMacro(), grabArgs(), handlePreambleTag(), headerMacrosLoad(), makeGPGSignature(), parsePreamble(), parseSpec(), rpmcliInstall(), rpmLoadMacros(), rpmPlatform(), rpmRebuildTargetVars(), rpmtsOpenSDB(), setDefaults(), and setPathDefault().

static int compareMacroName | ( | const void * | ap,
|  | const void * | bp
| ) |  |
| static

Compare macro entries by name (qsort/bsearch).

Parameters

  ap | 1st macro entry
  bp | 2nd macro entry

Returns
  result of comparison

Definition at line 176 of file macro.c.

Referenced by findEntry(), and sortMacroTable().

void delMacro | ( | MacroContext | mc,
|  | const char * | n
| ) |  |

Delete macro from context.

Parameters

  mc | macro context (NULL uses global context).
  n | macro name

Definition at line 2438 of file macro.c.

References findEntry(), popMacro(), rpmGlobalMacroContext, and sortMacroTable().

Referenced by doUndefine(), handlePreambleTag(), headerMacrosUnload(), makeGPGSignature(), parseSpec(), rpmcliInstall(), rpmRebuildTargetVars(), and rpmtsOpenSDB().

static const char* doDefine | ( | MacroBuf | mb,
|  | const char * | se,
|  | int | level,
|  | int | expandbody
| ) |  |
| static

Parse (and execute) new macro definition.

Parameters

  mb | macro expansion state
  se | macro definition to parse
  level | macro recursion level
  expandbody | should body be expanded?

Returns
  address to continue parsing

Definition at line 720 of file macro.c.

References _, _macro_BUFSIZ, addMacro(), alloca(), COPYNAME, COPYOPTS, expandU(), isblank, iseol, matchchar(), MacroBuf_s::mc, rpmlog(), RPMLOG_ERR, SKIPBLANK, and xisalpha().

Referenced by expandMacro(), and rpmDefineMacro().

static void doFoo | ( | MacroBuf | mb,
|  | int | negate,
|  | const char * | f,
|  | size_t | fn,
|  | const char * | g,
|  | size_t | gn
| ) |  |
| static

Execute macro primitives.

Parameters

  mb | macro expansion state
  negate | should logic be inverted?
  f | beginning of field f
  fn | length of field f
  g | beginning of field g
  gn | length of field g

Definition at line 1215 of file macro.c.

References _macro_BUFSIZ, alloca(), COMPRESSED_OTHER, expandT(), expandU(), getenv(), isblank, isCompressed(), PATH_MAX, realpath(), rpmlog(), RPMLOG_ERR, RPMLOG_INFO, RPMLOG_MASK, rpmlogSetMask(), rpmuuidMake(), stpcpy(), stpncpy(), STREQ, urlPath(), uuid_ns, uuid_version, xisdigit(), and xisspace().

Referenced by expandMacro().

static void doOutput | ( | MacroBuf | mb,
|  | int | waserror,
|  | const char * | msg,
|  | size_t | msglen
| ) |  |
| static

Perform macro message output.

Parameters

  mb | macro expansion state
  waserror | use rpmError()?
  msg | message to ouput
  msglen | no. of bytes in message

Definition at line 1189 of file macro.c.

References _macro_BUFSIZ, alloca(), expandU(), rpmlog(), and RPMLOG_ERR.

Referenced by expandMacro().

static int doShellEscape | ( | MacroBuf | mb,
|  | const char * | cmd,
|  | size_t | clen
| ) |  |
| static

Expand output of shell command into target buffer.

Parameters

  mb | macro expansion state
  cmd | shell command
  clen | no. bytes in shell command

Returns
  result of expansion

Definition at line 681 of file macro.c.

References _macro_BUFSIZ, alloca(), expandU(), iseol, MacroBuf_s::nb, SAVECHAR, and MacroBuf_s::t.

Referenced by expandMacro().

static const char* doUndefine | ( | MacroContext | mc,
|  | const char * | se
| ) |  |
| static

Parse (and execute) macro undefinition.

Parameters

  mc | macro context
  se | macro name to undefine

Returns
  address to continue parsing

Definition at line 855 of file macro.c.

References _, _macro_BUFSIZ, alloca(), COPYNAME, delMacro(), iseol, rpmlog(), RPMLOG_ERR, and xisalpha().

Referenced by expandMacro(), and rpmUndefineMacro().

static char* dupMacroEntry | ( | MacroEntry | me | ) |
| static

Definition at line 240 of file macro.c.

References stpcpy(), and xmalloc().

Referenced by rpmGetMacroEntries().

static int expandFIFO | ( | MacroBuf | mb,
|  | MacroEntry | me,
|  | const char * | g,
|  | size_t | gn
| ) |  |
| static

Definition at line 1433 of file macro.c.

References expandT().

Referenced by expandMacro().

static int expandMacro | ( | MacroBuf | mb | ) |
| static

Parse args and string for PHP like %{foo <args> : <string> } syntax.

Parameters

  s | "{ ... }" construct to parse
  nb | no. of bytes

Return values

  *avp | invocation args

Returns
  script string The main macro recursion loop.

Todo:
  Dynamically reallocate target buffer.

Parameters

  mb | macro expansion state

Returns
  0 on success, 1 on failure

Definition at line 1617 of file macro.c.

References _, _free(), addMacro(), alloca(), MacroBuf_s::depth, doDefine(), doFoo(), doOutput(), doShellEscape(), doUndefine(), MacroBuf_s::expand_trace, expandFIFO(), expandT(), findEntry(), freeArgs(), grabArgs(), isblank, iseol, MacroBuf_s::macro_trace, matchchar(), max_macro_depth, MacroBuf_s::mc, MacroBuf_s::nb, print_expand_trace, print_macro_trace, printExpansion(), printMacro(), RMIL_GLOBAL, rpmDumpMacroTable(), rpmLoadMacroFile(), rpmlog(), RPMLOG_ERR, rpmluaGetGlobalState(), rpmluaGetPrintBuffer(), rpmluaRunScript(), RPMRC_OK, MacroBuf_s::s, SAVECHAR, STREQ, MacroBuf_s::t, xisalnum(), xisdigit(), and xmalloc().

Referenced by expandMacros(), expandT(), and expandU().

int expandMacros | ( | void * | spec,
|  | MacroContext | mc,
|  | char * | sbuf,
|  | size_t | slen
| ) |  |

Expand macro into buffer.

Deprecated:
  Use rpmExpand().

Todo:
  Eliminate from API.

Parameters

  spec | cookie (unused)
  mc | macro context (NULL uses global context).

Return values

  sbuf | input macro to expand, output expansion

Parameters

  slen | size of buffer

Returns
  0 on success

Definition at line 2364 of file macro.c.

References _, alloca(), MacroBuf_s::depth, MacroBuf_s::expand_trace, expandMacro(), MacroBuf_s::macro_trace, MacroBuf_s::mc, MacroBuf_s::nb, print_expand_trace, print_macro_trace, rpmGlobalMacroContext, rpmlog(), RPMLOG_ERR, MacroBuf_s::s, MacroBuf_s::spec, and MacroBuf_s::t.

Referenced by addFileToTagAux(), copyNextLineFromOFI(), processPackageFiles(), rpmExpand(), rpmGetPath(), and rpmMCExpand().

static void expandMacroTable | ( | MacroContext | mc | ) |
| static

Enlarge macro table.

Parameters

  mc | macro context

Definition at line 196 of file macro.c.

References MACRO_CHUNK_SIZE, xmalloc(), and xrealloc().

Referenced by addMacro().

static int expandT | ( | MacroBuf | mb,
|  | const char * | f,
|  | size_t | flen
| ) |  |
| static

Save source and expand field into target.

Parameters

  mb | macro expansion state
  f | field
  flen | no. bytes in field

Returns
  result of expansion

Definition at line 591 of file macro.c.

References alloca(), expandMacro(), and MacroBuf_s::s.

Referenced by doFoo(), expandFIFO(), and expandMacro().

static int expandU | ( | MacroBuf | mb,
|  | char * | u,
|  | size_t | ulen
| ) |  |
| static

Save source/target and expand macro in u.

Parameters

  mb | macro expansion state
  u | input macro, output expansion
  ulen | no. bytes in u buffer

Returns
  result of expansion

Definition at line 644 of file macro.c.

References alloca(), expandMacro(), MacroBuf_s::nb, MacroBuf_s::s, and MacroBuf_s::t.

Referenced by doDefine(), doFoo(), doOutput(), doShellEscape(), and grabArgs().

static MacroEntry* findEntry | ( | MacroContext | mc,
|  | const char * | name,
|  | size_t | namelen
| ) |  |
| static

Find entry in macro table.

Parameters

  mc | macro context
  name | macro name
  namelen | no. of bytes

Returns
  address of slot in macro table with name (or NULL)

Definition at line 349 of file macro.c.

References alloca(), compareMacroName(), and rpmGlobalMacroContext.

Referenced by addMacro(), delMacro(), and expandMacro().

static void freeArgs | ( | MacroBuf | mb | ) |
| static

Free parsed arguments for parameterized macro.

Parameters

  mb | macro expansion state

Definition at line 963 of file macro.c.

References _, MacroBuf_s::depth, MacroBuf_s::mc, popMacro(), rpmlog(), RPMLOG_ERR, and sortMacroTable().

Referenced by expandMacro().

static const char* grabArgs | ( | MacroBuf | mb,
|  | const MacroEntry | me,
|  | const char * | se,
|  | const char * | lastc
| ) |  |
| static

Parse arguments (to next new line) for parameterized macro.

Todo:
  Use popt rather than getopt to parse args.

Parameters

  mb | macro expansion state
  me | macro entry slot
  se | arguments to parse
  lastc | stop parsing at lastc

Returns
  address to continue parsing

Definition at line 1014 of file macro.c.

References _, _free(), _macro_BUFSIZ, addMacro(), alloca(), MacroBuf_s::depth, expandU(), isblank, MacroBuf_s::mc, rpmlog(), RPMLOG_ERR, stpcpy(), and xcalloc().

Referenced by expandMacro().

int isCompressed | ( | const char * | file,
|  | rpmCompressedMagic * | compressed
| ) |  |

Return type of compression used in file.

Parameters

  file | name of file

Return values

  compressed | address of compression type

Returns
  0 on success, 1 on I/O error

Definition at line 2668 of file macro.c.

References _, COMPRESSED_BZIP2, COMPRESSED_LZMA, COMPRESSED_LZOP, COMPRESSED_NOT, COMPRESSED_OTHER, COMPRESSED_XZ, COMPRESSED_ZIP, Fclose(), Ferror(), Fopen(), Fread(), Fstrerror(), rpmlog(), and RPMLOG_ERR.

Referenced by doFoo(), doPatch(), and doUntar().

static const char* matchchar | ( | const char * | p,
|  | char | pl,
|  | char | pr
| ) |  |
| static

Return text between pl and matching pr characters.

Parameters

  p | start of text
  pl | left char, i.e. '[', '(', '{', etc.
  pr | right char, i.e. ']', ')', '}', etc.

Returns
  address of last char before pr (or NULL)

Definition at line 451 of file macro.c.

Referenced by doDefine(), and expandMacro().

static void popMacro | ( | MacroEntry * | mep | ) |
| static

Pop macro definition from macro entry stack.

Parameters

  mep | address of macro entry slot

Definition at line 941 of file macro.c.

References _free().

Referenced by delMacro(), and freeArgs().

static void printExpansion | ( | MacroBuf | mb,
|  | const char * | t,
|  | const char * | te
| ) |  |
| static

Post-print expanded macro expression.

Parameters

  mb | macro expansion state
  t | current expansion string result
  te | end of string

Definition at line 521 of file macro.c.

References _, MacroBuf_s::depth, and iseol.

Referenced by expandMacro().

static void printMacro | ( | MacroBuf | mb,
|  | const char * | s,
|  | const char * | se
| ) |  |
| static

Pre-print macro expression to be expanded.

Parameters

  mb | macro expansion state
  s | current expansion string
  se | end of string

Definition at line 477 of file macro.c.

References _, MacroBuf_s::depth, and iseol.

Referenced by expandMacro().

static void pushMacro | ( | MacroEntry * | mep,
|  | const char * | n,
|  | const char * | o,
|  | const char * | b,
|  | int | level
| ) |  |
| static

Push new macro definition onto macro entry stack.

Parameters

  mep | address of macro entry slot
  n | macro name
  o | macro parameters (NULL if none)
  b | macro body (NULL becomes "")
  level | macro recursion level

Definition at line 908 of file macro.c.

References _free(), name::name, xmalloc(), and xstrdup().

Referenced by addMacro().

static char* rdcl | ( | char * | buf,
|  | size_t | size,
|  | FD_t | fd
| ) |  |
| static

fgets(3) analogue that reads \ continuations.

Last newline always trimmed.

Parameters

  buf | input buffer
  size | inbut buffer size (bytes)
  fd | file handle

Returns
  buffer, or NULL on end-of-file

Definition at line 387 of file macro.c.

References fdGetFILE, and iseol.

Referenced by rpmLoadMacroFile().

char* rpmCleanPath | ( | char * | path | ) |

Canonicalize file path.

Parameters

  path | path to canonicalize (in-place)

Returns
  pointer to path

Definition at line 2881 of file macro.c.

Referenced by db3open(), doLookup(), relocateFileList(), rpmGetPath(), rpmioAccess(), and rpmQueryVerify().

int rpmDefineMacro | ( | MacroContext | mc,
|  | const char * | macro,
|  | int | level
| ) |  |

Define macro in context.

Parameters

  mc | macro context (NULL uses global context).
  macro | macro name, options, body
  level | macro recursion level (0 is entry API)

Returns

Todo:
  Document.

Definition at line 2454 of file macro.c.

References alloca(), doDefine(), MacroBuf_s::mc, and rpmGlobalMacroContext.

Referenced by ftsCacheUpdate(), main(), rpmcliAllArgCallback(), rpmdbRebuild(), rpmioAllArgCallback(), and rpmLoadMacroFile().

void rpmDumpMacroTable | ( | MacroContext | mc,
|  | FILE * | fp
| ) |  |

Print macros to file stream.

Parameters

  mc | macro context (NULL uses global context).
  fp | file stream (NULL uses stderr).

Definition at line 268 of file macro.c.

References _, and rpmGlobalMacroContext.

Referenced by expandMacro(), and rpmShowRC().

char* rpmExpand | ( | const char * | arg,
|  |  | ...
| ) |  |

Return (malloc'ed) concatenated macro expansion(s).

Parameters

  arg | macro(s) to expand (NULL terminates list)

Returns
  macro expansion (malloc'ed)

Definition at line 2780 of file macro.c.

References _macro_BUFSIZ, expandMacros(), stpcpy(), xmalloc(), xrealloc(), and xstrdup().

Referenced by _GetPass(), addChangelog(), archScore(), checkForValidArchitectures(), checkUnpackagedFiles(), cpio_doio(), dbiTagsInit(), debevrfmtTag(), debmd5sumsTag(), defaultMachine(), doPatch(), doPrimary(), doSetupMacro(), fillOutMainPackage(), Fopen(), formatValue(), getMachineInfo(), handlePreambleTag(), headerMacrosLoad(), headerMacrosUnload(), i18nTag(), ignoreDep(), initGlobs(), initSourceHeader(), lookupPackage(), main(), makeGPGSignature(), open_dso(), packageBinaries(), parseBuildInstallClean(), parseForRegexLang(), parseForSimple(), parsePreamble(), parseSpec(), prepFetch(), processSourceFiles(), rdToken(), readLine(), Realpath(), repoDoRepoMetadata(), repoMDExpand(), rpmCheckPassPhrase(), rpmcliEvalSlurp(), rpmcliImportPubkeys(), rpmcliInstallElementPath(), rpmcliQuery(), rpmdbNew(), rpmdcParseZeroInstall(), rpmdsCpuinfo(), rpmdsEVRorder(), rpmdsGetconf(), rpmdsLdconfig(), rpmdsPipe(), rpmdsSysinfo(), rpmEVRmire(), rpmEVRorder(), rpmExpandNumeric(), rpmfcClassify(), rpmfcExec(), rpmfcExpandAppend(), rpmfcExpandRegexps(), rpmfcGenerateDependsHelper(), rpmgiNext(), rpmgiOpen(), rpmInstallSourcePackage(), rpmioAllArgCallback(), rpmmiAddPattern(), rpmnsArch(), rpmnsParse(), rpmnsProbeSignature(), rpmPlatform(), rpmReadConfigFiles(), rpmReadRC(), rpmRollback(), rpmShowProgress(), rpmShowRC(), rpmts_IDTXglob(), rpmtsAddInstallElement(), rpmtsAddObsoletes(), rpmtsAddUpgrades(), rpmtsEraseDebuginfo(), rpmtsFindPubkey(), rpmtsRollback(), rpmtsSolve(), runImmedTriggers(), runInstScript(), runScript(), runTriggers(), skipFiles(), spec_get_buildroot(), statFormat(), strsubFormat(), tagLoadATags(), tagValidate(), unsatisfiedDepend(), urlFind(), urlGetFile(), and writeRPM().

int rpmExpandNumeric | ( | const char * | arg | ) |

Return macro expansion as a numeric value.

Boolean values ('Y' or 'y' returns 1, 'N' or 'n' returns 0) are permitted as well. An undefined macro returns 0.

Parameters

  arg | macro to expand

Returns
  numeric value

Definition at line 2854 of file macro.c.

References _free(), and rpmExpand().

Referenced by checkPackageDeps(), checkUnpackagedFiles(), dbiOpen(), doIcon(), doPatchMacro(), getDigestAlgo(), main(), newSpec(), parseScript(), parseSpec(), processPackageFiles(), relocateFileList(), rpmcliInstall(), rpmcliQuery(), rpmcliVerify(), rpmdbInit(), rpmdbNew(), rpmdbOpen(), rpmdbRebuild(), rpmdbVerify(), rpmdsELF(), rpmErase(), rpmfcGenerateDepends(), rpmRollback(), rpmts_new(), rpmtsCreate(), rpmtsOpenSDB(), rpmtsOrder(), rpmtsRollback(), rpmtsRun(), skipFiles(), unsatisfiedDepend(), and urlGetFile().

void rpmFreeMacros | ( | MacroContext | mc | ) |

Destroy macro context.

Parameters

  mc | macro context (NULL uses global context).

Definition at line 2641 of file macro.c.

References _free(), and rpmGlobalMacroContext.

Referenced by main(), rpmcliFini(), rpmioFini(), and rpmspecQuery().

const char* rpmGenPath | ( | const char * | urlroot,
|  | const char * | urlmdir,
|  | const char * | urlfile
| ) |  |

Merge 3 args into path, any or all of which may be a url.

The leading part of the first URL encountered is used for the result, other URL prefixes are discarded, permitting a primitive form of URL inheiritance.

Parameters

  urlroot | root URL (often path to chroot, or NULL)
  urlmdir | directory URL (often a directory, or NULL)
  urlfile | file URL (often a file, or NULL)

Returns
  expanded, merged, canonicalized path (malloc'ed)

Definition at line 3005 of file macro.c.

References _free(), alloca(), rpmGetPath(), URL_IS_DASH, and urlPath().

Referenced by addSource(), createDir(), db3close(), db3open(), db_init(), doIcon(), doPatch(), doScript(), doSetupMacro(), doUntar(), handlePreambleTag(), isSpecFile(), main(), prepFetch(), processBinaryFile(), processMetadataFile(), processPackageFiles(), rpmdsNew(), rpmfcGenerateDepends(), rpmfiNew(), rpmpsmStage(), rpmTempFile(), sql_close(), sql_initDB(), and sql_open().

int rpmGetMacroEntries | ( | MacroContext | mc,
|  | void * | _mire,
|  | int | used,
|  | const char *** | avp
| ) |  |

Return macro entries as string array.

Parameters

  mc | macro context (NULL uses global context)
  _mire | pattern to match (NULL disables)
  used | macro usage (<0 all, =0 unused, >=1 used count)

Return values

  *avp | macro definitions

Returns
  no. of entries

Definition at line 302 of file macro.c.

References dupMacroEntry(), mireRegexec(), rpmGlobalMacroContext, xcalloc(), and xrealloc().

Referenced by packageSources(), and rpmtsFini().

const char* rpmGetPath | ( | const char * | path,
|  |  | ...
| ) |  |

Return (malloc'ed) expanded, canonicalized, file path.

Parameters

  path | macro(s) to expand (NULL terminates list)

Returns
  canonicalized path (malloc'ed)

Definition at line 2973 of file macro.c.

References _macro_BUFSIZ, alloca(), expandMacros(), rpmCleanPath(), stpcpy(), and xstrdup().

Referenced by addFileToTagAux(), buildSpec(), checkSpec(), Chroot(), db3close(), db3open(), defaultMachine(), doPatch(), doUntar(), genCpioListAndHeader(), initSourceHeader(), main(), packageBinaries(), packageSources(), parseFiles(), parseForSimple(), parseSpec(), processPackageFiles(), Realpath(), repoCloseMDFile(), repoDoFinalMove(), repoDoPkgMetadata(), repoDoRepoMetadata(), repoGetPath(), repoMkdir(), repoOpenMDFile(), repoTestSetupDirs(), repoWriteMetadataDocs(), rpmcliInit(), rpmcliInstallElementPath(), rpmdbExportInfo(), rpmdbMoveDatabase(), rpmdbRebuild(), rpmdbRemoveDatabase(), rpmdbURIPath(), rpmdsSysinfo(), rpmfiBuildREContexts(), rpmfiNew(), rpmGenPath(), rpmGetFilesystemUsage(), rpmpsmStage(), rpmQueryVerify(), rpmsxParse(), rpmtsFindPubkey(), rpmtsOpenDB(), rpmtsOpenSDB(), rpmtsPRCO(), rpmtsRun(), str2uuid(), and unsatisfiedDepend().

int rpmGlob | ( | const char * | patterns,
|  | int * | argcPtr,
|  | const char *** | argvPtr
| ) |  |

Return URL path(s) from a (URL prefixed) pattern glob.

Parameters

  patterns | glob pattern

Return values

  *argcPtr | no. of paths
  *argvPtr | array of paths (malloc'd contiguous blob)

Returns
  0 on success

Definition at line 2225 of file macro.c.

References _free(), glob_t::gl_pathc, glob_t::gl_pathv, Glob(), Glob_error(), Glob_pattern_p(), GLOB_TILDE, Globfree(), setlocale, URL_IS_DASH, URL_IS_FTP, URL_IS_HKP, URL_IS_HTTP, URL_IS_HTTPS, URL_IS_PATH, URL_IS_UNKNOWN, urlPath(), xmalloc(), XpoptParseArgvString(), xrealloc(), and xstrdup().

Referenced by IDTXglob(), processBinaryFile(), rpmcliInit(), rpmcliInstallElementPath(), rpmgiGlobArgv(), rpmInitMacros(), rpmioInit(), and rpmReadPackageManifest().

void rpmInitMacros | ( | MacroContext | mc,
|  | const char * | macrofiles
| ) |  |

Initialize macro context from set of macrofile(s).

Parameters

  mc | macro context
  macrofiles | colon separated list of macro files (NULL does nothing)

Definition at line 2555 of file macro.c.

References _free(), _suffix, RMIL_CMDLINE, rpmCLIMacroContext, rpmGlob(), rpmGlobalMacroContext, rpmLoadMacroFile(), rpmLoadMacros(), rpmlog(), RPMLOG_WARNING, rpmSecuritySaneFile(), xmalloc(), and xstrdup().

Referenced by rpmReadRC().

int rpmLoadMacroFile | ( | MacroContext | mc,
|  | const char * | fn
| ) |  |

Load macro context from a macro file.

Parameters

  mc | (unused)
  fn | macro file name

Definition at line 2516 of file macro.c.

References _macro_BUFSIZ, _MAX_MACRO_DEPTH, alloca(), Fclose(), Ferror(), Fopen(), max_macro_depth, rdcl(), RMIL_MACROFILES, rpmDefineMacro(), and SKIPBLANK.

Referenced by expandMacro(), and rpmInitMacros().

void rpmLoadMacros | ( | MacroContext | mc,
|  | int | level
| ) |  |

Load macros from specific context into global context.

Parameters

  mc | macro context (NULL does nothing).
  level | macro recursion level (0 is entry API)

Definition at line 2476 of file macro.c.

References addMacro(), and rpmGlobalMacroContext.

Referenced by rpmInitMacros().

char* rpmMCExpand | ( | MacroContext | mc,
|  | const char * | arg,
|  |  | ...
| ) |  |

Return (malloc'ed) concatenated macro expansion(s) in a context.

Parameters

  mc | macro context
  arg | macro(s) to expand (NULL terminates list)

Returns
  macro expansion (malloc'ed)

Definition at line 2817 of file macro.c.

References _macro_BUFSIZ, expandMacros(), stpcpy(), xmalloc(), xrealloc(), and xstrdup().

int rpmSecuritySaneFile | ( | const char * | filename | ) |

Check whether configuration file is moderately secure to load.

Parameters

  filename | filename to check

Returns
  1 on success, 0 on failure

Definition at line 2202 of file macro.c.

Referenced by rpmcliInit(), rpmInitMacros(), and rpmioInit().

int rpmUndefineMacro | ( | MacroContext | mc,
|  | const char * | macro
| ) |  |

Undefine macro in context.

Parameters

  mc | macro context (NULL uses global context).
  macro | macro name

Returns

Todo:
  Document.

Definition at line 2468 of file macro.c.

References doUndefine(), and rpmGlobalMacroContext.

Referenced by rpmcliAllArgCallback(), and rpmioAllArgCallback().

static void sortMacroTable | ( | MacroContext | mc | ) |
| static

Sort entries in macro table.

Parameters

  mc | macro context

Definition at line 218 of file macro.c.

References compareMacroName().

Referenced by addMacro(), delMacro(), and freeArgs().

static int XpoptDupArgv | ( | int | argc,
|  | const char ** | argv,
|  | int * | argcPtr,
|  | const char *** | argvPtr
| ) |  |
| static

< missing argument

< missing argument

< memory allocation failed

Definition at line 1459 of file macro.c.

References POPT_ERROR_MALLOC, POPT_ERROR_NOARG, and xmalloc().

Referenced by XpoptParseArgvString().

static int XpoptParseArgvString | ( | const char * | s,
|  | int * | argcPtr,
|  | const char *** | argvPtr
| ) |  |
| static

< memory allocation failed

< error in paramter quoting

< error in paramter quoting

Definition at line 1499 of file macro.c.

References alloca(), POPT_ARGV_ARRAY_GROW_DELTA, POPT_ERROR_BADQUOTE, POPT_ERROR_MALLOC, xmalloc(), and XpoptDupArgv().

Referenced by rpmGlob().

## Variable Documentation

int _debug = 0
| static

Definition at line 2223 of file macro.c.

size_t _macro_BUFSIZ = 16 * 1024
| static

Definition at line 156 of file macro.c.

Referenced by doDefine(), doFoo(), doOutput(), doShellEscape(), doUndefine(), grabArgs(), rpmExpand(), rpmGetPath(), rpmLoadMacroFile(), and rpmMCExpand().

int max_macro_depth = 16

Definition at line 141 of file macro.c.

Referenced by expandMacro(), and rpmLoadMacroFile().

int print_expand_trace = 0

Definition at line 149 of file macro.c.

Referenced by expandMacro(), and expandMacros().

int print_macro_trace = 0

Definition at line 145 of file macro.c.

Referenced by expandMacro(), and expandMacros().

MacroContext rpmCLIMacroContext = &rpmCLIMacroContext_s

Definition at line 114 of file macro.c.

Referenced by rpmcliAllArgCallback(), rpmcliFini(), rpmInitMacros(), rpmioAllArgCallback(), and rpmioFini().

struct MacroContext_s rpmCLIMacroContext_s
| static

Definition at line 112 of file macro.c.

MacroContext rpmGlobalMacroContext = &rpmGlobalMacroContext_s

Definition at line 109 of file macro.c.

Referenced by addMacro(), delMacro(), expandMacros(), findEntry(), newSpec(), rpmDefineMacro(), rpmDumpMacroTable(), rpmFreeMacros(), rpmGetMacroEntries(), rpmInitMacros(), rpmLoadMacros(), and rpmUndefineMacro().

struct MacroContext_s rpmGlobalMacroContext_s
| static

Definition at line 107 of file macro.c.